# See https://pre-commit.com for more information
# See https://pre-commit.com/hooks.html for more hooks
ci:
  skip: [pylint]
  autofix_prs: true
  autofix_commit_msg: "fix: [pre-commit.ci] auto fixes [...]"
  autoupdate_commit_msg: "chore(pre-commit): [pre-commit.ci] autoupdate"
  autoupdate_schedule: monthly
default_stages: [pre-commit, pre-push, manual]
repos:
  - repo: https://github.com/pre-commit/pre-commit-hooks
    rev: v5.0.0
    hooks:
      - id: check-symlinks
      - id: destroyed-symlinks
      - id: trailing-whitespace
      - id: end-of-file-fixer
      - id: check-yaml
      - id: check-toml
      - id: check-ast
      - id: check-added-large-files
      - id: check-merge-conflict
      - id: check-executables-have-shebangs
      - id: check-shebang-scripts-are-executable
      - id: detect-private-key
      - id: debug-statements
      - id: double-quote-string-fixer
  - repo: https://github.com/pre-commit/mirrors-clang-format
    rev: v19.1.7
    hooks:
      - id: clang-format
  - repo: https://github.com/astral-sh/ruff-pre-commit
    rev: v0.9.5
    hooks:
      - id: ruff
        args: [--fix, --exit-non-zero-on-fix]
      - id: ruff-format
  - repo: https://github.com/asottile/pyupgrade
    rev: v3.19.1
    hooks:
      - id: pyupgrade
        args: [--py38-plus]
  - repo: https://github.com/pycqa/flake8
    rev: 7.1.1
    hooks:
      - id: flake8
        additional_dependencies:
          - flake8-bugbear
          - flake8-comprehensions
          - flake8-docstrings
          - flake8-pyi
          - flake8-simplify
        exclude: |
          (?x)(
            ^tests/|
            ^docs/source/conf.py$
          )
  - repo: https://github.com/codespell-project/codespell
    rev: v2.4.1
    hooks:
      - id: codespell
        additional_dependencies: [".[toml]"]
  - repo: https://github.com/pre-commit/mirrors-mypy
    rev: v1.15.0
    hooks:
      - id: mypy
        exclude: |
          (?x)(
            ^tests/|
            ^setup.py$
          )
  - repo: local
    hooks:
      - id: pylint
        name: pylint
        entry: pylint
        language: system
        types: [python]
        require_serial: true
        exclude: |
          (?x)(
            ^tests/|
            ^setup.py$
          )
